#import "ViewController.h"

@interface ViewController ()
{
    IGOHLCSeriesDataSourceHelper *source;
    IGCategoryXAxis *xAxis;
    IGNumericYAxis *yAxis;
    IGChartView *chartView;
    IGFinancialPriceSeries *financialPriceSeries;
    NSMutableArray *chartData;
    
    NSMutableArray *dateArr, *openArr, *highArr, *lowArr, *closeArr, *volumeArr, *labelsArr;
}
@end

@implementation ViewController

//- (void)viewDidLoad {
//    [super viewDidLoad];
//    
//    _data = [self createChartData];
//    
//    _dsh = [[IGOHLCSeriesDataSourceHelper alloc]initWithData:_data openPath:@"open" highPath:@"high" lowPath:@"low" andClosePath:@"close"];
//    
//    _chart = [[IGChartView alloc]initWithFrame:self.view.frame];
//    
//    _series = (IGFinancialPriceSeries*)[_chart addSeriesForType:[IGFinancialPriceSeries class] usingKey:@"series" withDataSource:_dsh firstAxisKey:@"x" secondAxisKey:@"y"];
//    
//    _series.outline = [[IGBrush alloc]initWithColor:[UIColor darkGrayColor]];
//    _series.thickness = 3;
//    
//    _series.yAxis.minimum = 0;
//    _series.yAxis.maximum = 100;
//
//    
//    [self.view addSubview:_chart];
//}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    chartView = [[IGChartView alloc]initWithFrame:self.view.frame];
    
    chartData = [[NSMutableArray alloc]init];
    NSMutableDictionary *d1 = [[NSMutableDictionary alloc]init];
    [d1 setValue:[[NSNumber alloc]initWithDouble:20] forKey:@"open"];
    [d1 setValue:[[NSNumber alloc]initWithDouble:40] forKey:@"high"];
    [d1 setValue:[[NSNumber alloc]initWithDouble:10] forKey:@"low"];
    [d1 setValue:[[NSNumber alloc]initWithDouble:30] forKey:@"close"];
    [d1 setValue:[[NSNumber alloc]initWithDouble:50] forKey:@"volume"];
    [chartData addObject:d1];
    
    NSMutableDictionary *d2 = [[NSMutableDictionary alloc]init];
    [d2 setValue:[[NSNumber alloc]initWithDouble:30] forKey:@"open"];
    [d2 setValue:[[NSNumber alloc]initWithDouble:40] forKey:@"high"];
    [d2 setValue:[[NSNumber alloc]initWithDouble:10] forKey:@"low"];
    [d2 setValue:[[NSNumber alloc]initWithDouble:20] forKey:@"close"];
    [d2 setValue:[[NSNumber alloc]initWithDouble:50] forKey:@"volume"];
    [chartData addObject:d2];
    
    NSMutableDictionary *d3 = [[NSMutableDictionary alloc]init];
    [d3 setValue:[[NSNumber alloc]initWithDouble:20] forKey:@"open"];
    [d3 setValue:[[NSNumber alloc]initWithDouble:40] forKey:@"high"];
    [d3 setValue:[[NSNumber alloc]initWithDouble:10] forKey:@"low"];
    [d3 setValue:[[NSNumber alloc]initWithDouble:30] forKey:@"close"];
    [d3 setValue:[[NSNumber alloc]initWithDouble:50] forKey:@"volume"];
    [chartData addObject:d3];
    
    NSMutableDictionary *d4 = [[NSMutableDictionary alloc]init];
    [d4 setValue:[[NSNumber alloc]initWithDouble:20] forKey:@"open"];
    [d4 setValue:[[NSNumber alloc]initWithDouble:40] forKey:@"high"];
    [d4 setValue:[[NSNumber alloc]initWithDouble:10] forKey:@"low"];
    [d4 setValue:[[NSNumber alloc]initWithDouble:30] forKey:@"close"];
    [d4 setValue:[[NSNumber alloc]initWithDouble:50] forKey:@"volume"];
    [chartData addObject:d4];
    
    dateArr = [[NSMutableArray alloc] init];
    openArr = [[NSMutableArray alloc] init];
    highArr = [[NSMutableArray alloc] init];
    lowArr = [[NSMutableArray alloc] init];
    closeArr = [[NSMutableArray alloc] init];
    volumeArr = [[NSMutableArray alloc] init];
    labelsArr = [[NSMutableArray alloc] init];
    
    int counter = 0;
    
    for (NSDictionary* dict in chartData)
    {
        NSDate *date = [NSDate dateWithTimeIntervalSinceNow:counter * 3600 * 24];
        double open = [[dict valueForKey:@"open"] doubleValue];
        double high = [[dict valueForKey:@"high"] doubleValue];
        double low = [[dict valueForKey:@"low"] doubleValue];
        double close = [[dict valueForKey:@"close"] doubleValue];
        int64_t volume = [[dict valueForKey:@"volume"] doubleValue];
        
        [dateArr addObject:date];
        [openArr addObject:[[NSNumber alloc] initWithDouble:open]];
        [highArr addObject:[[NSNumber alloc] initWithDouble:high]];
        [lowArr addObject:[[NSNumber alloc] initWithDouble:low]];
        [closeArr addObject:[[NSNumber alloc] initWithDouble:close]];
        [volumeArr addObject:[[NSNumber alloc] initWithDouble:volume]];
        [labelsArr addObject:[NSString stringWithFormat:@"Item %d", counter]];
        
        counter ++;
    }
    
    source = [[IGOHLCSeriesDataSourceHelper alloc] init];
    source.openValues = openArr;
    source.highValues = highArr;
    source.lowValues = lowArr;
    source.closeValues = closeArr;
    source.volumeValues = volumeArr;
    source.labels = labelsArr;
    
    xAxis = [[IGCategoryXAxis alloc] initWithKey:@"xAxis"];
    yAxis = [[IGNumericYAxis alloc] initWithKey:@"yAxis"];
    xAxis.labelOrientationAngle = 45;
    
    yAxis.minimum = 0;
    yAxis.maximum = 100;
    
    [chartView addAxis:xAxis];
    [chartView addAxis:yAxis];
    
    financialPriceSeries = [[IGFinancialPriceSeries alloc] initWithKey:@"financialPriceSeries"];
    financialPriceSeries.xAxis = xAxis;
    financialPriceSeries.yAxis = yAxis;
    financialPriceSeries.dataSource = source;
    financialPriceSeries.displayType = IGPriceDisplayTypeCandlestick;
    financialPriceSeries.brush = [[IGBrush alloc]initWithColor:[UIColor greenColor]];
    financialPriceSeries.negativeBrush = [[IGBrush alloc]initWithColor:[UIColor redColor]];
    financialPriceSeries.xAxis.majorStrokeThickness = 0.6f;
    financialPriceSeries.yAxis.majorStrokeThickness = 0.6f;
    financialPriceSeries.xAxis.majorStroke = [[IGBrush alloc]initWithColor:[UIColor lightGrayColor]];
    financialPriceSeries.yAxis.majorStroke = [[IGBrush alloc]initWithColor:[UIColor lightGrayColor]];
    
    IGChartThemeDefinition* theme = [[IGChartThemeDefinition alloc]init];
    theme.font = [UIFont fontWithName:@"Helvetica" size:14];
    theme.fontColor = [[IGBrush alloc] initWithR:106.0/255.0 andG:113.0/255.0 andB:120.0/255.0 andA:1];
    IGChartPaletteItem* item1 = [[IGChartPaletteItem alloc] init];
    item1.color = [[IGBrush alloc] initWithR:8.0/255.0 andG:204.0/255.0 andB:224.0/255.0 andA:1];
    item1.outlineColor = [[IGBrush alloc] initWithR:8.0/255.0 andG:204.0/255.0 andB:224.0/255.0 andA:1];
    
    //[theme.seriesPalettes addObject:item1];
    
            chartView.theme = theme;
    chartView.animateSeriesWhenAxisRangeChanges = TRUE;
    [chartView addSeries:financialPriceSeries];
    
    [self.view addSubview:chartView];
}

//-(NSArray*)createChartData
//{
//    NSMutableArray *array = [[NSMutableArray alloc]init];
//    for (int i=0; i<15; i++)
//    {
//        ChartData *obj = [[ChartData alloc]init];
//        obj.low = arc4random()%20 + 5;
//        obj.high = arc4random()%10 + 50;
//        obj.open = arc4random()%25 + 25;
//        obj.close = arc4random()%25 + 25;
//        [array addObject:obj];
//    }
//    return array;
//}
@end

@implementation ChartData
@end